!= Module HistoryFileIO
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: historyfileio.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ե. Ĺ֥ƥåפͤ.
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module HistoryFileIO
  !
  !ե. Ĺ֥ƥåפͤ.
  !

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use gtool_historyauto, only: HistoryAutoCreate, HistoryAutoClose, &
    & HistoryAutoAddAttr, HistoryAutoAddWeight, HistoryAutoPutAxis

  ! ե
  ! File I/O support
  !
  use dc_iounit, only: FileOpen
  
  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP, &      ! ټ¿. Double precision. 
    &                 STRING, &  ! ʸ.       Strings. 
    &                 TOKEN,  &  ! .   Keywords. 
    &                 STDOUT     ! ɸϤֹ. Unit number of standard output
  use axesset,  only: x_X, y_Y, z_Z
  use gridset, only:  nx, ny, nz
  use fileset,  only: DefaultFilePrefix, &!ҥȥե̾
    &                 filetitle,        &!ǡɽ
    &                 filesource,       &!ǡ
    &                 FileInstitution    !ǽѹԡȿ
  use timeset, only: StartTime, EndTime

  !ۤηػ
  implicit none
  
  !°λ
  private

  !³
  public HistoryFileAutoOpen
  public HistoryFileAutoClose

  ! ѿ
  ! Private variables
  !
  character(*), parameter:: module_name = 'history_file_io'
                              ! ⥸塼̾. 
                              ! Module name
  character(*), parameter:: version = &
    & '$Name:  $' // &
    & '$Id: historyfileio.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $'
                              ! ⥸塼ΥС
                              ! Module version

  ! INTERFACE ʸ ; INTERFACE statements
  !
  interface HistoryFileAutoOpen
    module procedure HistoryFileAutoOpen
  end interface

  interface HistoryFileAutoClose
    module procedure HistoryFileAutoClose
  end interface

contains 

!!!------------------------------------------------------------------------
  subroutine HistoryFileAutoOpen( cfgfile ) 
    !
    ! history_file_io ⥸塼νԤޤ. 
    !--
    ! NAMELIST#history_file_io_nml ɤ߹ߤϤμ³ǹԤޤ. 
    !++
    !
    ! "history_file_io" module is initialized. 
    !--
    ! "NAMELIST#history_file_io_nml" is loaded in this procedure. 
    !++
    !

    ! ⥸塼 ; USE statements
    !

    ! gtool5 netCDF ǡϥ󥿡ե (絬ϥǥ)
    ! Interface of Input/Output of gtool5 netCDF data (For large models)
    !

    ! ʸ ; Declaration statements
    !
    implicit none
    
    !ѿ
    character(STRING), intent(in) :: cfgfile
    real(DP), parameter       :: TimeDisp = 1.0e5 !ϴֳ֤Υǥե

    !-----------------------------------------------------------
    ! ҥȥ꡼
    !-----------------------------------------------------------
    call HistoryAutoCreate(                             &
      & title = FileTitle,                              &
      & source = FileSource,                            &
      & institution = FileInstitution,                  &
      & dims=(/'x','y','z','t'/),                       &
      & dimsizes=(/nx, ny, nz, 0/),                     &
      & longnames=(/'x-coordinate',                     &
      &             'y-coordinate',                     &
      &             'z-coordinate',                     &
      &             'time        '/),                   &
      & units=(/'m  ','m  ','m  ','sec'/),              &
      & xtypes=(/'double','double','double','double'/), &
      & origin   = StartTime,                           & 
      & terminus = EndTime,                             &
      & interval = TimeDisp,                            &       
!      & flag_mpi_split = .true.,                        &
!      & file_prefix = DefaultFilePrefix,                & 
      & namelist_filename = cfgfile)  

    call HistoryAutoAddAttr( &
      & varname = 'x', attrname = 'standard_name', &   ! (in)
      & value = 'x-coordinate' )                       ! (in)
    call HistoryAutoAddAttr( &
      & varname = 'y', attrname = 'standard_name', &   ! (in)
      & value = 'y-coordinate' )                       ! (in)
    call HistoryAutoAddAttr( &
      & varname = 'z', attrname = 'standard_name', &   ! (in)
      & value = 'z-coordinate' )                       ! (in)
    
    call HistoryAutoPutAxis('x', x_X(1:nx))
    call HistoryAutoPutAxis('y', y_Y(1:ny))
    call HistoryAutoPutAxis('z', z_Z(1:nz))

    !  ; Print
    !
!    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
!    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
    
  end subroutine HistoryFileAutoOpen


  subroutine HistoryFileAutoClose
    !
    ! ҥȥǡեϤνλԤޤ. 
    !
    ! Terminate history data files output. 

    ! ⥸塼 ; USE statements
    !

    ! ʸ ; Declaration statements
    !
    implicit none

    ! ѿ
    ! Work variables
    !

    ! ¹ʸ ; Executable statement
    !

    call HistoryAutoClose

  end subroutine HistoryFileAutoClose

end module HistoryFileIO
