!= Module FileSet
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: fileset.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!Ϳ줿 NAMELIST ե뤫, ե̾ɽξ
!ݴɤ뤿ѿ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module fileset
  !
  !Ϳ줿 NAMELIST ե뤫, I/O ե̾, 
  !ݴɤ뤿ѿ⥸塼
  !

  !⥸塼ɤ߹
  use dc_types,    only : STRING 
  use dc_iounit,   only : FileOpen
  use dc_message,  only : MessageNotify
  use mpi_wrapper, only: myrank

  !ۤηػ
  implicit none

  private

  !ѿ
  character(STRING), save, public :: InputFile = ""                     !ꥹȥե
  character(STRING), save, public :: InputFilePrefix = ""               !ꥹȥե
  character(STRING), save, public :: OutputFile = ""                    !ꥹȥե
  character(STRING), save, public :: OutputFilePrefix = ""              !ꥹȥե
  character(STRING), save, public :: HistoryFile  = "deepconv"     !ҥȥ꡼եƬ
  character(STRING), save, public :: HistoryFilePrefix = "deepconv"     !ҥȥ꡼եƬ
  character(STRING), save, public :: DefaultFilePrefix = ""             !ҥȥե̾
  character(STRING), save, public :: FileTitle = 'Simulation of an atmosphere of planet with the land and the ocean'
                              ! ϥǡեɽ.
                              ! Title of output data files
  character(STRING), save, public :: FileSource = 'deepconv/arare5 $Name:  $ (http://www.gfd-dennou.org/library/deepconv)'
                              ! ǡեμ. 
                              ! Source of data file
  character(STRING), save, public :: FileInstitution = 'GFD Dennou Club (http://www.gfd-dennou.org)'
                              ! ǡեǽŪѹȿ/Ŀ. 
                              ! Institution or person that changes data files for the last time
  public fileset_init


contains

  subroutine fileset_init(cfgfile)
    !
    !NAMELIST ե̾դ륿, ϥե̾. 
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    character(STRING), intent(in) :: cfgfile
    integer                       :: unit     !ֹ
    character(3)                  :: Rank 
    
    !NAMELIST 
    NAMELIST /fileset_nml/   &
      & InputFilePrefix, OutputFilePrefix, HistoryFilePrefix, &
      & FileTitle, FileSource, FileInstitution, HistoryFile  
    
    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=fileset_nml)
    close(unit)
    
    !ΡֹѰ
    call fileset_setnum(rank) !(inout)
    
    ! InitialFile
    if (trim(InputFilePrefix) /= '') then 
      InputFile = trim(InputFilePrefix)//"-rank"//trim(rank)//"_restart.nc"
    end if
    
    ! HistoryFile Ƭ
    DefaultFilePrefix = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_"
    
    ! ꥹȥե
    OutputFile  = trim(OutputFilePrefix)//"-rank"//trim(rank)//"_restart.nc" 
    
    !ǧ
    if (myrank == 0) then 
      call MessageNotify( "M", &
        & "fileset_init", "HistoryFilePrefix=%c", c1=trim(HistoryFilePrefix) )
      call MessageNotify( "M", &
        & "fileset_init", "InputFilePrefix=%c", c1=trim(InputFilePrefix) )
      call MessageNotify( "M", &
        & "fileset_init", "OutputFilePrefix=%c", c1=trim(OutputFilePrefix) )
      call MessageNotify( "M", &
        & "fileset_init", "DefaultFilePrefix=%c", c1=trim(DefaultFilePrefix) )
      call MessageNotify( "M", &
        & "fileset_init", "FileTitle = %c",    c1=trim(FileTitle) )
      call MessageNotify( "M", &
        & "fileset_init", "FileSource = %c",   c1=trim(FileSource) )
      call MessageNotify( "M", &
        & "fileset_init", "FileInstitution = %c", c1=trim(FileInstitution) )
    end if

  end subroutine fileset_init


  subroutine fileset_setnum(rank)

    character(3), intent(inout) :: rank 

   !Ρֹʸ
   rank = "000"
   if (myrank < 10) then 
     write(rank(3:3), 100) myrank
100  format(I1)
   else if (myrank < 100 ) then 
     write(rank(2:3), 200) myrank
200  format(I2)
   else if (myrank < 1000 ) then 
     write(rank(1:3), 300) myrank
300  format(I3)
   end if
 end subroutine fileset_setnum

end module fileset
