!= Module NumDiffusion
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu 
! Version::   $Id: numdiffusion.f90,v 1.1 2011-04-26 04:08:11 sugiyama Exp $
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview
!
!ͳȻη׻⥸塼
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!

module NumDiffusion
  !
  !ͳȻη׻⥸塼
  !ߤ 2 濴ʬ
  !

  !⥸塼ɤ߹
  use dc_types,   only: DP, STRING
  use dc_iounit,  only: FileOpen
  use dc_message, only: MessageNotify

  use gridset, only:  imin,           &! x β
    &                 imax,           &! x ξ
    &                 jmin,           &! y β
    &                 jmax,           &! y ξ
    &                 kmin,           &! z β
    &                 kmax,           &! z ξ
    &                 nf               !
  use axesset, only:  x_dx,           &! X γʻֳ
    &                 y_dy,           &! X γʻֳ
    &                 z_dz             ! Z γʻֳ
  use timeset, only:  DelTimeLong      !Ĺ֥ƥå
  use xyz_deriv_module, only: xyz_dx_pyz, xyz_dy_xqz, xyz_dz_xyr, &
    &                         pyz_dx_xyz, xqz_dy_xyz, xyr_dz_xyz, &
    &                         xyr_dx_pyr, pyz_dy_pqz, pyz_dz_pyr, & 
    &                         pyr_dx_xyr, pqz_dy_pyz, pyr_dz_pyz, &
    &                         xqz_dx_pqz, xyr_dy_xqr, xqz_dz_xqr, &
    &                         pqz_dx_xqz, xqr_dy_xyr, xqr_dz_xqz


  !ۤηػ
  implicit none
  
  !°λ
  private

  !ؿ public ˤ
  public NumDiffusion_Init
  public xyz_NumDiffScalar
  public xyz_NumDiffKm
  public xyza_NumDiffScalar
  public pyz_NumDiffVelX
  public xqz_NumDiffVelY
  public xyr_NumDiffVelZ

  !ѿ
  real(DP), save  :: NuH   = 0.0d0   !Ǵη (ʿ)
  real(DP), save  :: NuV   = 0.0d0   !Ǵη (ľ)
  real(DP), save  :: Alpha = 1.0d-4
  real(DP), save  :: factor = 1.0d0  !®٤ФǴ夲Ͽ 1 ʾˤ. 

contains

!!!-------------------------------------------------------------------!!!
  subroutine NumDiffusion_init(cfgfile)
    !
    ! NumDiffusion ⥸塼ν롼
    !

    !ۤηػ
    implicit none

    character(STRING), intent(in) :: cfgfile
    real(DP) :: DelXMin, DelYMin, DelZMin
    integer  :: unit

    !-----------------------------------------------------------------
    ! NAMELIST 
    !
    NAMELIST /numdiffusion_nml/ Alpha, factor
    
    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=numdiffusion_nml)
    close(unit)

    DelXMin = minval(x_dx)
    DelYMin = minval(y_dy)
    DelZMin = minval(z_dz)
    
    ! CReSS ޥ˥奢Ǥ, 2 濴ʬξ, Alpha < 1/8 餤ŬȽҤ٤Ƥ. 
    ! deepconv Ǥ NuH Ȥ 500 ʾͤäƤ,
    NuH  = Alpha * ( SQRT(DelXMin*DelYMin) ** 2.0d0 ) / DelTimeLong
    NuV  = Alpha * ( DelZMin ** 2.0d0 ) / DelTimeLong
    
    !ǧ
    call MessageNotify( "M", "NumDiffusion_init", "NuH = %f", d=(/NuH/) )
    call MessageNotify( "M", "NumDiffusion_init", "NuV = %f", d=(/NuV/) )
    call MessageNotify( "M", "NumDiffusion_init", "factor = %f", d=(/factor/) )

  end subroutine NumDiffusion_init


!!!-------------------------------------------------------------------!!!
  function xyz_NumDiffKm(xyz_Scalar)
    !
    ! x, z ȾʻҤ줿ǤοͳȻɾ
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in) :: xyz_Scalar(imin:imax,jmin:jmax,kmin:kmax)
                                                    !顼
    real(8)             :: xyz_NumDiffKm(imin:imax,jmin:jmax,kmin:kmax)
                                                    !ʿοͳȻ
    
    xyz_NumDiffKm =   &
      &    NuH * (xyz_dx_pyz(pyz_dx_xyz( xyz_Scalar ))) &
      &  + NuH * (xyz_dy_xqz(xqz_dy_xyz( xyz_Scalar ))) &
      &  + NuV * (xyz_dz_xyr(xyr_dz_xyz( xyz_Scalar ))) 
    
  end function xyz_NumDiffKmo

!!!-------------------------------------------------------------------!!!
  function xyza_NumDiffScalar(xyza_Scalar)
    !
    ! x, z ȾʻҤ줿ǤοͳȻɾ
    !
    
    !ۤηػ
    implicit none!

    !ѿ
    real(DP), intent(in) :: xyza_Scalar &
      &                     (imin:imax,jmin:jmax,kmin:kmax,nf)
                                                    !顼
    real(DP)             :: xyza_NumDiffScalar &
      &                     (imin:imax,jmin:jmax,kmin:kmax,nf)
                                                    !ʿοͳȻ
    integer             :: s
    

    do s = 1, nf
      xyza_NumDiffScalar(:,:,:,s) =   &
        &    NuH * (xyz_dx_pyz(pyz_dx_xyz( xyza_Scalar(:,:,:,s) ))) &
        &  + NuH * (xyz_dy_xqz(xqz_dy_xyz( xyza_Scalar(:,:,:,s) ))) &
        &  + NuV * (xyz_dz_xyr(xyr_dz_xyz( xyza_Scalar(:,:,:,s) ))) 
    end do

  end function xyza_NumDiffScalar


!!!-------------------------------------------------------------------!!!
  function pyz_NumDiffVelX(pyz_VarX)
    !
    ! z ȾʻҤ줿ǤοͳȻɾ
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: pyz_VarX &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                                    !ʪ
    real(DP)             :: pyz_NumDiffVelX &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                                    !ͳȻ
    
    pyz_NumDiffVelX = &
      &   factor * NuH * ( pyz_dx_xyz( xyz_dx_pyz( pyz_VarX ) ) ) &
      & + factor * NuH * ( pyz_dy_pqz( pqz_dy_pyz( pyz_VarX ) ) ) &
      & + factor * NuV * ( pyz_dz_pyr( pyr_dz_pyz( pyz_VarX ) ) )
    
  end function pyz_NumDiffVelX
  

!!!-------------------------------------------------------------------!!!
  function xqz_NumDiffVelY(xqz_VarY)
    !
    ! z ȾʻҤ줿ǤοͳȻɾ
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: xqz_VarY &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                                    !ʪ
    real(DP)             :: xqz_NumDiffVelY &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                                    !ͳȻ
    
    xqz_NumDiffVelY = &
      &   factor * NuH * ( xqz_dx_pqz( pqz_dx_xqz( xqz_VarY ) ) ) &
      & + factor * NuH * ( xqz_dy_xyz( xyz_dy_xqz( xqz_VarY ) ) ) &
      & + factor * NuV * ( xqz_dz_xqr( xqr_dz_xqz( xqz_VarY ) ) )
    
  end function xqz_NumDiffVelY


!!!-------------------------------------------------------------------!!!  
  function xyr_NumDiffVelZ(xyr_VarZ)
    !
    ! x ȾʻҤ줿ǤοͳȻɾ
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: xyr_VarZ(imin:imax,jmin:jmax,kmin:kmax)
                                                    !ʪ
    real(DP)             :: xyr_NumDiffVelZ(imin:imax,jmin:jmax,kmin:kmax)
                                                    !ͳȻ

    xyr_NumDiffVelZ = &
      &   factor * NuH * ( xyr_dx_pyr( pyr_dx_xyr( xyr_VarZ ) ) ) &
      & + factor * NuH * ( xyr_dy_xqr( xqr_dy_xyr( xyr_VarZ ) ) ) & 
      & + factor * NuV * ( xyr_dz_xyz( xyz_dz_xyr( xyr_VarZ ) ) )
    
  end function xyr_NumDiffVelZ

end module NumDiffusion

  
